#include "01_09_01_quickimage.h"

int main()
{
	int i,j;
	Image* I = NouvelleImage(256,256);
	for(i=0;i<256;i++)
	{
		for(j=0;j<256;j++)
		{
			Pixel p;
			p.r = i;
			p.g = j;
			p.b = 0;
			SetPixel(I,i,j,p);
		}
	}
	//Image* I = Charger("test.ppm");
	Sauver(I,"test.ppm");
	DelImage(I);
	return 0;
}


/*!F
	Voici un exemple pour crire et lire des fichiers PPM sans utiliser de librairies externes.
	Les fichiers PPM sont des formats d'image trs simple  lire et crire.

	Ils se relisent avec toute sorte de logiciels de dessin (cependant, Windows (avec Paint), ne les remonte pas nativement)
	Vous pouvez utiliser ACDSEE, ou bien XnView, ou tout autre logiciel de dessin.

	Le programme est simple :

// Regardez le .h

	On a une structure Pixel.

	Un pixel, c'est 3 couleurs : rouge, vert, bleu, qui varient de 0  255 chacun. 
	Avec a, vous pouvez faire toutes les couleurs possible.

	Nous avons galement une structure Image, qui contient une taille (largeur w et hauteut h) (de l'anglais width et height)
	et un tableau de pixels.

	Voila comment on dfinit une image en mmoire.

	Les fonctions que j'ai fait avec :

	Une fonction NouvelleImage : vous lui donnez une taille, elle construit la structure
	Une fonction DelImage : qui dtruit, dsalloue une image
	Une fonction CopieImage : qui recopie une image

	Vous n'aurez aucun malloc  faire dans votre main pour manipuler le tout.

	Une fonction GetPixel, et une autre SetPixel : vous leur donnez l'image, les coordonnes i,j du pixel voulu, et hop, 
	elles lisent/crivent le pixel en mmoire.

	Charger et Sauver, qui chargent et sauvent une image PPM. 

// Regardez le main

	Une utilisation trs simple du tout : on cre une image de 255*255 pixels, on fait un double for, 
	et on fait varier le rouge sur l'axe x, et le vert sur l'axe y.

	On sauve le tout : regardez le rsultat dans votre rpertoire avec un logiciel de dessin : l'image est un beau dgrad.

// Le format PPM

	Le format PPM est simple :
	C'est un format Texte. Vous crivez d'abord le header P3, puis les dimensions de l'image, suivi du nombre maximal (chez nous 255)

	Puis tous les pixels les uns aprs les autres.
	Explication supplmentaire :
	http://fr.wikipedia.org/wiki/Portable_pixmap#Fichier_ASCII_3

	Vous remarquerez sur cette page qu'on peut aussi crire des fichiers PPM binaires, 
	mais aussi des PBM (noir et blanc : juste noir OU blanc), et PGM (nuances de gris) tout aussi simples  crire.
	
!*/

/*!E
	No explanations yet.
!*/

/*
titre: Lire et crire des fichiers image PPM
titreE: Read and Write a PPM file.
meta: C;PPM natif
metaE: C;native PPM 
desc: Lire et crire nativement des fichiers image PPM
descE: Read and Write a PPM file from scratch
cle  : 
linkT: 01_09_01_quickimage.h
linkT: 01_09_01_quickimage.c
parag: 1.9. Manipuler nativement des fichiers connus.
paragE: 1.9. Read and Write some known files types.
*/
